/* pphunt - finds PP20 files embedded in other files */
#include <stdlib.h>
#include <stdio.h>

size_t filelen;
void *loadfile(char *name) {
  void *mem = NULL; FILE *fd;
  if ((fd = fopen(name, "rb"))) {
    if ((fseek(fd, 0, SEEK_END) == 0) && (filelen = ftell(fd))
    &&  (fseek(fd, 0, SEEK_SET) == 0) && (mem = malloc(filelen))) {
      if (fread(mem, 1, filelen, fd) < filelen) { free(mem); mem = NULL; }
    }
    fclose(fd);
  }
  return mem;
}

#define READ_BITS(nb, v) do {					\
    for (bc = (nb); bl < bc; bl += 8) {				\
	if (buf < src) return 0; /* out of source bits */	\
	bb |= (*--buf << bl);					\
    }								\
    (v)=0; bl-=bc; while(bc--){(v)<<=1; (v)|=bb&1; bb>>=1;}	\
} while (0)


/* this pretends to decrunch a data stream. If it wasn't decrypted
 * exactly right, it will access match offsets that don't exist, or
 * request match lengths that there isn't enough data for, or will
 * underrun or overrun the theoretical output buffer
 */
int ppValidate(unsigned char *src, unsigned char *olens,
	       unsigned int src_len, unsigned int dest_len,
	       unsigned char skip_bits)
{
    unsigned int written=0, bb=0, x, y, ob, offset, bl=0, bc;
    unsigned char *buf = &src[src_len];
    READ_BITS(skip_bits, x);
    while (written < dest_len) {
	READ_BITS(1, x);
	if (x == 0) {
	    y = 1; do { READ_BITS(2, x); y += x; } while (x == 3);
	    written += y; if (written > dest_len) break;
	    while (y--) READ_BITS(8, x);
	    if (written == dest_len) break;
	}
	READ_BITS(2, x); ob = olens[x]; y = x + 2;
	if (x == 3) {
	    READ_BITS(1, x); if (x==0) ob=7; READ_BITS(ob, offset);
	    do { READ_BITS(3, x); y += x; } while (x == 7);
	} else { READ_BITS(ob, offset); }
	if (offset >= written) break;
	written += y; if (written > dest_len) break;
    }
    return (written == dest_len);
}                     

int main(int argc, char *argv[]) {
    int i, pos, len;
    unsigned char *data;

    if (argc < 2) return 1;

    for (i = 1; i < argc; i++) {
	if (! (data = (unsigned char *) loadfile(argv[i]))) {
	    perror(argv[i]);
	    continue;
	}

	for (pos = 0; pos < (int)filelen; pos++) {
	    if (data[pos+0] != 'P' || data[pos+1] != 'P' ||
		data[pos+2] != '2' || data[pos+3] != '0') continue;
	    for (len = 16; len < ((int)filelen - pos); len += 4) {
		if (ppValidate(&data[pos+8], &data[pos+4], len-12,
			       (data[pos+len-4]<<16) | (data[pos+len-3]<<8) | data[pos+len-2],
			       data[pos+len-1]))
		{
		    printf("%s: offset %d length %d\n",argv[i], pos, len);
		}
	    }
	}
	free(data);
    }
    return 0;
}
